// servomoter.ino
//
// サーボモータを動かす（サーボモータ使用）
// 
// Written by Nobuki HIRAMINE
// Last modified : 2011/12/03

#include <Servo.h>

#define SERVOPIN	(9)
#define VOLUMEPIN	(0)

Servo g_servo;

void setup() 
{ 
	g_servo.attach(SERVOPIN);
} 

int Map( int iIn, int iIn1, int iIn2, int iOut1, int iOut2, boolean bConstrain = false )
{
	double dValue = (double)(iIn - iIn1) * (iOut2 - iOut1) / (iIn2 - iIn1) + iOut1;
	int iValue = (0 < dValue) ? (int)(dValue + 0.5) : (int)(dValue - 0.5);
	if( bConstrain )
	{
		int iOutMin, iOutMax;
		if( iOut1 < iOut2 )
		{
			iOutMin= iOut1;
			iOutMax= iOut2;
		}
		else
		{
			iOutMin= iOut2;
			iOutMax= iOut1;
		}
		if( iOutMin > iValue )
		{
			return iOutMin;
		}
		if( iOutMax < iValue )
		{
			return iOutMax;
		}
	}
	return iValue;
}

void loop() 
{ 
	int iValue = analogRead(VOLUMEPIN);
	int iAngle = Map(iValue, 0, 1023, 0, 180, true);
	g_servo.write(iAngle);
	delay(15);
} 
